# -*- coding: utf-8 -*-
"""
Created on Fri May 15 13:38:08 2020

@author: icruicks
"""

from tweet_utilities import Twitter_Hashtag_Data_Extractor, Create_Interaction_Graph
import pickle as pkl, numpy as np, os, time, igraph as ig
from collections import OrderedDict
from multiprocessing import Pool
from Leiden_Clustering import MVMC


if __name__ == '__main__':
    
    data_directory = os.path.join("/storage3", "coronavirus", "json_keyword_stream")
    save_directory = os.path.join("/storage", "icruicks", "Data", "Coronavirus")
    
    # data_directory = os.path.join("Data", "Coronavirus")
    # save_directory = os.path.join("Data", "Coronavirus")
    
    '''
    Part 1: Get the data from JSON into something usable in Python
    '''
    # # def parse_data(file_name):
    # for file_name in os.listdir(data_directory):
    #     if file_name.endswith("json.gz"):
    #     # if (file_name.endswith("json.gz") and file_name[14]=='2'):
    #         print(file_name)
    #         # Get the name(s) of the Twitter Data to read in
    #         # file_name = "Data/Coronavirus/virus_v3_2020_3_11.json.gz"
            
            
    #         ## Extract hashtag data from the Twitter file
    #         hashtag_ext = Twitter_Hashtag_Data_Extractor()
    #         hashtag_ext.fit(os.path.join(data_directory,file_name))
            
    #         text_data = hashtag_ext.text_dict
    #         retweets_data = hashtag_ext.retweets_dict
    #         tweet_counts = hashtag_ext.tweet_count_dict
    #         quotes_data = hashtag_ext.quotes_dict
    #         replies_data = hashtag_ext.replies_dict
    #         mentions_data = hashtag_ext.mentions_dict
    #         user_data = hashtag_ext.user_dict
    #         urls_data = hashtag_ext.urls_dict
    #         user_names = hashtag_ext.screen_names
    #         co_occurence_data = hashtag_ext.co_occurence_dict
            
    #         ## Save processed data
    #         with open(os.path.join(save_directory, "processed_data",file_name[-17:-8]+".p"), 'wb') as pkl_file:
    #             pkl.dump([text_data, retweets_data, tweet_counts, 
    #                       quotes_data, replies_data, mentions_data, 
    #                       user_data, urls_data, user_names, 
    #                       co_occurence_data], pkl_file)
    
    # t1 = time.time()
    
    # with Pool(processes=8) as p:
    #     p.map(parse_data, os.listdir(data_directory))
        
    # t2 = time.time()
    # print("Time for extracting user data from raw JSON: {} minutes"
    #       .format(np.round((t2-t1)/60,3)))
    
    '''
    Part two: create similarity graphs of the data
    '''    
    # for file_name in os.listdir(os.path.join(save_directory, "processed_data")):
    #     if (file_name.endswith(".p") and file_name[5]!='2'):
    #     # if file_name.endswith("2_1.p"):
    #         print(file_name)
    #         with open(os.path.join(save_directory, "processed_data",file_name), 'rb') as pkl_file:
    #             [text_data, retweets_data, tweet_counts, 
    #                       quotes_data, replies_data, mentions_data, 
    #                       user_data, urls_data, user_names, 
    #                       co_occurence_data]= pkl.load(pkl_file)
                
    #         ## Remove no hashtags
    #         co_occurence_data.pop('None', None)
    #         user_data.pop('None', None)
    #         urls_data.pop('None', None)
    #         text_data.pop('None', None)
            
    #         ## Create graphs
    #         t3 = time.time()
    #         data = [co_occurence_data, user_data, urls_data]
    #         # graphs = [Create_Interaction_Graph(vectorizer_type ='tf_idf').fit_transform(view) for view in data]
    #         try:
    #             with Pool(processes=3) as p:
    #                 graphs = p.map(Create_Interaction_Graph(vectorizer_type ='tf_idf').fit_transform, data)
    #         except:
    #             graphs = [Create_Interaction_Graph(vectorizer_type ='tf_idf').fit_transform(view) for view in data]
    #         graphs.append(Create_Interaction_Graph(vectorizer_type ='tf_idf', data_type='text').fit_transform(text_data))
    #         t4 = time.time()
    #         print("Time for creating view interaction similarity graphs: {} minutes"
    #               .format(np.round((t4-t3)/60,3)))
            
    #         ## Save processed graphs
    #         node_names = list(co_occurence_data.keys())
    #         with open(os.path.join(save_directory, "graphs",file_name), 'wb') as pkl_file:
    #             pkl.dump([node_names, graphs], pkl_file)
    
    
    '''
    Part three: multi-view cluster the simialrity graphs
    '''
    def cluster(file_name):
    # for file_name in os.listdir(os.path.join(save_directory, "graphs")):
        if file_name.endswith(".p"):
        # if (file_name.endswith(".p") and file_name[5]=='2'):
            print(file_name)

            with open(os.path.join(save_directory, "graphs",file_name), 'rb') as pkl_file:
                [node_names, graphs]= pkl.load(pkl_file)
                
            ## Now, cluster the graphs and save out the results
            t5 = time.time()
            mvmc_clstr= MVMC(resolution_tol=0.1, weight_tol=0.05)
            community_labels = mvmc_clstr.fit_transform(graphs)
            t6 = time.time()
            print("Time for MVMC for {}: {} minutes"
                  .format(file_name, np.round((t6-t5)/60,3)))
            performance_results ={}
            performance_results['modularity'] = mvmc_clstr.modularities[-1]
            performance_results['resolution'] = mvmc_clstr.resolutions[-1]
            performance_results['weights'] = mvmc_clstr.weights[-1]
            performance_results['iterations'] = mvmc_clstr.final_iteration
    
            with open(os.path.join(save_directory,"hashtag_communities",file_name), 'wb') as pkl_file:
                pkl.dump([node_names, community_labels, performance_results], pkl_file)
                
    
    with Pool(processes=12) as p:
        p.map(cluster, os.listdir(os.path.join(save_directory, "graphs")))
                
                